diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/print-introspected-doxygen.cc ns-3.42/utils/print-introspected-doxygen.cc
--- ns-3.41/utils/print-introspected-doxygen.cc	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/print-introspected-doxygen.cc	2024-05-29 15:29:47.228073800 -0700
@@ -1227,15 +1227,7 @@
        << "AttributeValue implementation for " << name << "\n";
     if (seeBase)
     {
-        // Some classes don't live in ns3::.  Yuck
-        if (name != "IeMeshId")
-        {
-            os << seeAlso << "ns3::" << name << "\n";
-        }
-        else
-        {
-            os << seeAlso << "ns3::dot11s::" << name << "\n";
-        }
+        os << seeAlso << "ns3::" << name << "\n";
     }
     os << commentStop;
 
@@ -1271,20 +1263,12 @@
     os << seeAlso << "AttributeValue" << std::endl;
     os << commentStop;
 
-    // Copy ctor: <name>Value::<name>Value
-    os << commentStart << functionStart << name << qualClass << "::" << valClass;
-    if ((name == "EmptyAttribute") || (name == "ObjectPtrContainer"))
-    {
-        // Just default constructors.
-        os << "()\n";
-    }
-    else
-    {
-        // Copy constructors
-        os << "(const " << type << " & value)\n"
-           << "Copy constructor.\n"
-           << argument << "[in] value The " << name << " value to copy.\n";
-    }
+    // Ctor: <name>Value::<name>Value
+    os << commentStart << functionStart << qualClass << "::" << valClass;
+    // Constructors
+    os << "(const " << type << " & value)\n"
+       << "Constructor.\n"
+       << argument << "[in] value The " << name << " value to use.\n";
     os << commentStop;
 
     // <name>Value::Get () const
@@ -1430,7 +1414,6 @@
       { "Box",            "Box",            true,  "box.h"              },
       { "DataRate",       "DataRate",       true,  "data-rate.h"        },
       { "Length",         "Length",         true,  "length.h"           },
-      { "IeMeshId",       "IeMeshId",       true,  "ie-dot11s-id.h"     },
       { "Ipv4Address",    "Ipv4Address",    true,  "ipv4-address.h"     },
       { "Ipv4Mask",       "Ipv4Mask",       true,  "ipv4-address.h"     },
       { "Ipv6Address",    "Ipv6Address",    true,  "ipv6-address.h"     },
@@ -1439,9 +1422,6 @@
       { "Mac48Address",   "Mac48Address",   true,  "mac48-address.h"    },
       { "Mac64Address",   "Mac64Address",   true,  "mac64-address.h"    },
       { "ObjectFactory",  "ObjectFactory",  true,  "object-factory.h"   },
-      { "OrganizationIdentifier",
-                          "OrganizationIdentifier",
-                                            true,  "vendor-specific-action.h" },
       { "Priomap",        "Priomap",        true,  "prio-queue-disc.h"  },
       { "QueueSize",      "QueueSize",      true,  "queue-size.h"       },
       { "Rectangle",      "Rectangle",      true,  "rectangle.h"        },
@@ -1449,7 +1429,6 @@
       { "TypeId",         "TypeId",         true,  "type-id.h"          },
       { "UanModesList",   "UanModesList",   true,  "uan-tx-mode.h"      },
       { "ValueClassTest", "ValueClassTest", false, "attribute-test-suite.cc" /* core/test/ */  },
-      { "Vector",         "Vector",         true,  "vector.h"           },
       { "Vector2D",       "Vector2D",       true,  "vector.h"           },
       { "Vector3D",       "Vector3D",       true,  "vector.h"           },
       { "Waypoint",       "Waypoint",       true,  "waypoint.h"         },
@@ -1457,11 +1436,10 @@
 
       // All three (Value, Access and Checkers) defined, but custom
       { "Boolean",        "bool",           false, "boolean.h"          },
-      { "Callback",       "Callback",       true,  "callback.h"         },
+      { "Callback",       "CallbackBase",   true,  "callback.h"         },
       { "Double",         "double",         false, "double.h"           },
-      { "Enum",           "int",            false, "enum.h"             },
+      { "Enum",           "T",              false, "enum.h"             },
       { "Integer",        "int64_t",        false, "integer.h"          },
-      { "Pointer",        "Pointer",        false, "pointer.h"          },
       { "String",         "std::string",    false, "string.h"           },
       { "Time",           "Time",           true,  "nstime.h"           },
       { "Uinteger",       "uint64_t",       false, "uinteger.h"         },
@@ -1476,17 +1454,6 @@
         ++i;
     }
 
-    // Special cases
-    PrintAttributeValueSection(os, "EmptyAttribute", false);
-    PrintAttributeValueWithName(os, "EmptyAttribute", "EmptyAttribute", "attribute.h");
-
-    PrintAttributeValueSection(os, "ObjectPtrContainer", false);
-    PrintAttributeValueWithName(os,
-                                "ObjectPtrContainer",
-                                "ObjectPtrContainer",
-                                "object-ptr-container.h");
-    PrintMakeChecker(os, "ObjectPtrContainer", "object-ptr-container.h");
-
     PrintAttributeValueSection(os, "ObjectVector", false);
     PrintMakeAccessors(os, "ObjectVector");
     PrintMakeChecker(os, "ObjectVector", "object-vector.h");
@@ -1495,19 +1462,6 @@
     PrintMakeAccessors(os, "ObjectMap");
     PrintMakeChecker(os, "ObjectMap", "object-map.h");
 
-    PrintAttributeValueSection(os, "Pair", false);
-    PrintAttributeValueWithName(os, "Pair", "std::pair<A, B>", "pair.h");
-    PrintMakeChecker(os, "Pair", "pair.h");
-
-    PrintAttributeValueSection(os, "Tuple", false);
-    PrintAttributeValueWithName(os, "Tuple", "std::tuple<Args...>", "tuple.h");
-    PrintMakeChecker(os, "Tuple", "tuple.h");
-
-    // AttributeContainer is already documented.
-    // PrintAttributeValueSection  (os, "AttributeContainer", false);
-    // PrintAttributeValueWithName (os, "AttributeContainer", "AttributeContainer",
-    // "attribute-container.h");
-    PrintMakeChecker(os, "AttributeContainer", "attribute-container.h");
 } // PrintAttributeImplementations ()
 
 /***************************************************************
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/python-unit-tests.py ns-3.42/utils/python-unit-tests.py
--- ns-3.41/utils/python-unit-tests.py	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/python-unit-tests.py	2024-05-29 15:29:47.228073800 -0700
@@ -202,7 +202,7 @@
         @param self this object
         @return None
         """
-        ns.Config.SetDefault("ns3::OnOffApplication::PacketSize", ns.core.UintegerValue(123))
+        ns.Config.SetDefault("ns3::OnOffApplication::PacketSize", ns.UintegerValue(123))
         # hm.. no Config.Get?
 
     def testSocket(self):
@@ -212,7 +212,7 @@
         """
         nc = ns.NodeContainer(1)
         node = nc.Get(0)
-        internet = ns.CreateObject("InternetStackHelper")
+        internet = ns.InternetStackHelper()
         internet.Install(node)
         self._received_packet = None
 
@@ -228,19 +228,15 @@
         """
         )
 
-        sink = ns.network.Socket.CreateSocket(
-            node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
-        )
-        sink.Bind(ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), 80).ConvertTo())
+        sink = ns.Socket.CreateSocket(node, ns.TypeId.LookupByName("ns3::UdpSocketFactory"))
+        sink.Bind(ns.InetSocketAddress(ns.Ipv4Address.GetAny(), 80).ConvertTo())
         sink.SetRecvCallback(ns.cppyy.gbl.make_rx_callback_test_socket(python_rx_callback))
 
-        source = ns.network.Socket.CreateSocket(
-            node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
-        )
+        source = ns.Socket.CreateSocket(node, ns.TypeId.LookupByName("ns3::UdpSocketFactory"))
         source.SendTo(
-            ns.network.Packet(19),
+            ns.Packet(19),
             0,
-            ns.network.InetSocketAddress(ns.network.Ipv4Address("127.0.0.1"), 80).ConvertTo(),
+            ns.InetSocketAddress(ns.Ipv4Address("127.0.0.1"), 80).ConvertTo(),
         )
 
         ns.Simulator.Run()
@@ -255,28 +251,28 @@
         @param self this object
         @return None
         """
-        # Templated class DropTailQueue<Packet> in C++
-        queue = ns.CreateObject("DropTailQueue<Packet>")
-        queueSizeValue = ns.network.QueueSizeValue(ns.network.QueueSize("500p"))
+        # Templated class DropTailQueue[ns.Packet] in C++
+        queue = ns.CreateObject[ns.DropTailQueue[ns.Packet]]()
+        queueSizeValue = ns.QueueSizeValue(ns.QueueSize("500p"))
         queue.SetAttribute("MaxSize", queueSizeValue)
 
-        limit = ns.network.QueueSizeValue()
+        limit = ns.QueueSizeValue()
         queue.GetAttribute("MaxSize", limit)
-        self.assertEqual(limit.Get(), ns.network.QueueSize("500p"))
+        self.assertEqual(limit.Get(), ns.QueueSize("500p"))
 
         ## -- object pointer values
-        mobility = ns.CreateObject("RandomWaypointMobilityModel")
-        ptr = ns.CreateObject("PointerValue")
+        mobility = ns.CreateObject[ns.RandomWaypointMobilityModel]()
+        ptr = ns.PointerValue()
         mobility.GetAttribute("PositionAllocator", ptr)
-        self.assertEqual(ptr.GetObject(), ns.core.Ptr["Object"](ns.cppyy.nullptr))
+        self.assertEqual(ptr.GetObject(), ns.Ptr["Object"](ns.cppyy.nullptr))
 
-        pos = ns.mobility.ListPositionAllocator()
+        pos = ns.ListPositionAllocator()
         ptr.SetObject(pos)
         mobility.SetAttribute("PositionAllocator", ptr)
 
-        ptr2 = ns.CreateObject("PointerValue")
+        ptr2 = ns.PointerValue()
         mobility.GetAttribute("PositionAllocator", ptr2)
-        self.assertNotEqual(ptr.GetObject(), ns.core.Ptr["Object"](ns.cppyy.nullptr))
+        self.assertNotEqual(ptr.GetObject(), ns.Ptr["Object"](ns.cppyy.nullptr))
 
         # Delete Ptr<>'s on the python side to let C++ clean them
         del queue, mobility, ptr, ptr2
@@ -286,8 +282,8 @@
         @param self this object
         @return None
         """
-        csma = ns.CreateObject("CsmaNetDevice")
-        channel = ns.CreateObject("CsmaChannel")
+        csma = ns.CreateObject[ns.CsmaNetDevice]()
+        channel = ns.CreateObject[ns.CsmaChannel]()
         csma.Attach(channel)
 
         c1 = csma.GetChannel()
@@ -324,7 +320,7 @@
         test4Buffer = create_string_buffer(b"this is a test option", BUFFLEN)
         test4 = c_char_p(test4Buffer.raw)
 
-        cmd = ns.core.CommandLine(__file__)
+        cmd = ns.CommandLine(__file__)
         cmd.AddValue("Test1", "this is a test option", test1)
         cmd.AddValue("Test2", "this is a test option", test2)
         cmd.AddValue["double"]("Test3", "this is a test option", test3)
@@ -351,7 +347,7 @@
         """
 
         ## MyNode class
-        class MyNode(ns.network.Node):
+        class MyNode(ns.Node):
             def GetLocalTime(self) -> ns.Time:
                 return ns.Seconds(10)
 
@@ -367,20 +363,20 @@
         """
         ns.Simulator.Destroy()
 
-        nodes = ns.network.NodeContainer()
+        nodes = ns.NodeContainer()
         nodes.Create(2)
 
-        pointToPoint = ns.point_to_point.PointToPointHelper()
-        pointToPoint.SetDeviceAttribute("DataRate", ns.core.StringValue("5Mbps"))
-        pointToPoint.SetChannelAttribute("Delay", ns.core.StringValue("2ms"))
+        pointToPoint = ns.PointToPointHelper()
+        pointToPoint.SetDeviceAttribute("DataRate", ns.StringValue("5Mbps"))
+        pointToPoint.SetChannelAttribute("Delay", ns.StringValue("2ms"))
 
         devices = pointToPoint.Install(nodes)
 
-        stack = ns.internet.InternetStackHelper()
+        stack = ns.InternetStackHelper()
         stack.Install(nodes)
 
-        address = ns.internet.Ipv4AddressHelper()
-        address.SetBase(ns.network.Ipv4Address("10.1.1.0"), ns.network.Ipv4Mask("255.255.255.0"))
+        address = ns.Ipv4AddressHelper()
+        address.SetBase(ns.Ipv4Address("10.1.1.0"), ns.Ipv4Mask("255.255.255.0"))
 
         interfaces = address.Assign(devices)
 
@@ -401,7 +397,7 @@
         )
 
         ## EchoServer application class
-        class EchoServer(ns.applications.Application):
+        class EchoServer(ns.Application):
             LOGGING = False
             ECHO_PORT = 1234
             socketToInstanceDict = {}
@@ -419,13 +415,11 @@
                 ## Listen port for the server
                 self.port = port
                 ## Socket used by the server to listen to port
-                self.m_socket = ns.network.Socket.CreateSocket(
-                    node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory")
+                self.m_socket = ns.Socket.CreateSocket(
+                    node, ns.TypeId.LookupByName("ns3::UdpSocketFactory")
                 )
                 self.m_socket.Bind(
-                    ns.network.InetSocketAddress(
-                        ns.network.Ipv4Address.GetAny(), self.port
-                    ).ConvertTo()
+                    ns.InetSocketAddress(ns.Ipv4Address.GetAny(), self.port).ConvertTo()
                 )
                 self.m_socket.SetRecvCallback(ns.make_rx_callback(EchoServer._Receive))
                 EchoServer.socketToInstanceDict[self.m_socket] = self
@@ -507,18 +501,18 @@
 
         serverApps = ns.ApplicationContainer()
         serverApps.Add(echoServer)
-        serverApps.Start(ns.core.Seconds(1.0))
-        serverApps.Stop(ns.core.Seconds(10.0))
+        serverApps.Start(ns.Seconds(1.0))
+        serverApps.Stop(ns.Seconds(10.0))
 
         address = interfaces.GetAddress(1).ConvertTo()
-        echoClient = ns.applications.UdpEchoClientHelper(address, EchoServer.ECHO_PORT)
-        echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(10))
-        echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds(1.0)))
-        echoClient.SetAttribute("PacketSize", ns.core.UintegerValue(101))
+        echoClient = ns.UdpEchoClientHelper(address, EchoServer.ECHO_PORT)
+        echoClient.SetAttribute("MaxPackets", ns.UintegerValue(10))
+        echoClient.SetAttribute("Interval", ns.TimeValue(ns.Seconds(1.0)))
+        echoClient.SetAttribute("PacketSize", ns.UintegerValue(101))
 
         clientApps = echoClient.Install(nodes.Get(0))
-        clientApps.Start(ns.core.Seconds(2.0))
-        clientApps.Stop(ns.core.Seconds(10.0))
+        clientApps.Start(ns.Seconds(2.0))
+        clientApps.Stop(ns.Seconds(10.0))
 
         ns.Simulator.Run()
         ns.Simulator.Destroy()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/tests/test-ns3.py ns-3.42/utils/tests/test-ns3.py
--- ns-3.41/utils/tests/test-ns3.py	2024-02-09 14:44:08.633795300 -0800
+++ ns-3.42/utils/tests/test-ns3.py	2024-05-29 15:29:47.228073800 -0700
@@ -1064,7 +1064,10 @@
                 f.write(ns3rc_template.format(modules="'lte'", examples="False", tests="True"))
 
             # Reconfigure.
-            return_code, stdout, stderr = run_ns3('configure -G "{generator}"')
+            run_ns3("clean")
+            return_code, stdout, stderr = run_ns3(
+                'configure -G "{generator}" -d release --enable-verbose'
+            )
             self.config_ok(return_code, stdout, stderr)
 
             # Check.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/VERSION ns-3.42/VERSION
--- ns-3.41/VERSION	2024-02-09 14:45:45.430484000 -0800
+++ ns-3.42/VERSION	2024-05-29 15:30:03.724115800 -0700
@@ -1 +1 @@
-3.41
+3.42
